<template>
  <button type="button" class="btn" :class="getClass">
    <span v-if="!spinner">{{title}}</span>
    <span v-if="spinner" class="spinner-border spinner-border-sm"></span>
    <span v-if="spinner">Loading..</span>
  </button>
</template>

<script>
export default {
  name: 'base-button',
  props: {
    title: {
      type: String,
      description: 'Button title',
      default: 'Button title'
    },
    btnStyle: {
      type: String,
      description: 'Button style.',
      default: ''
    },
    size: {
      type: String,
      description: 'Use the lg class for large buttons or sm class for small.',
      default: ''
    },
    block: {
      type: Boolean,
      description: 'Set block prog is true to create a block level button that spans the entire width of the parent element.',
      default: false
    },
    status: {
      type: String,
      description: 'Button status.',
      default: ''
    },
    spinner: {
      type: Boolean,
      description: 'Add loadding',
      default: false
    }
  },
  computed: {
    getClass () {
      console.log(this.btnStyle, [
        this.btnStyle && `btn-${this.btnStyle}`,
        this.size && `btn-${this.size}`,
        this.block && 'btn-block',
        this.status && this.status
      ])
      return [
        this.btnStyle && `btn-${this.btnStyle}`,
        this.size && `btn-${this.size}`,
        this.block && 'btn-block',
        this.status && this.status
      ]
    }
  }
}
</script>
